<template>
  <q-layout view="lHh Lpr lFf">
    <q-header elevated>
      <q-toolbar>
        <q-btn
          flat
          dense
          round
          icon="menu"
          aria-label="Menu"
          @click="toggleLeftDrawer"
        />

        <q-toolbar-title> User Management System </q-toolbar-title>
      </q-toolbar>
    </q-header>

    <q-drawer
      dark
      v-model="leftDrawerOpen"
      show-if-above
      bordered
      class="my-drawer-bg"
    >
      <q-list>
        <q-item-label header class="tablist"> TABS </q-item-label>

        <EssentialLink
          class="essential"
          v-for="link in essentialLinks"
          :key="link.title"
          v-bind="link"
        />
      </q-list>
    </q-drawer>

    <q-page-container>
      <router-view />
    </q-page-container>
  </q-layout>
</template>

<script>
import { defineComponent, ref } from "vue";
import EssentialLink from "components/EssentialLink.vue";

const linksList = [
  {
    title: "USER FORM",
    icon: "group_add",
    route_name: "user-form",
  },
  {
    title: "LIST OF USERS",
    icon: "table_rows",
    route_name: "user-list",
  },
];

export default defineComponent({
  name: "MainLayout",

  components: {
    EssentialLink,
  },

  setup() {
    const leftDrawerOpen = ref(false);

    return {
      essentialLinks: linksList,
      leftDrawerOpen,
      toggleLeftDrawer() {
        leftDrawerOpen.value = !leftDrawerOpen.value;
      },
    };
  },
});
</script>

<style>
.tablist {
  font-size: 30px;
  color: rgb(255, 255, 255);
  text-align: center;
  margin-bottom: 50px;
  background-color: black;
}
.my-drawer-bg {
  background-color: rgb(58, 53, 53);
}
.essential {
  font-size: 20px;
  font-weight: bold;
}
</style>
